package SGP_Backend.SGP_Backend.dto;

import SGP_Backend.SGP_Backend.domain.Escopo;
import SGP_Backend.SGP_Backend.model.Beneficio;
import SGP_Backend.SGP_Backend.model.Projeto;
import jakarta.persistence.*;
import lombok.Builder;
import lombok.Getter;
import lombok.Setter;

import java.util.ArrayList;
import java.util.List;

@Getter
@Setter
@Builder
public class BeneficioDTO {
    private Long id;
    private String beneficio;
    private Long projetoId;

    public BeneficioDTO(Beneficio beneficio) {
        this.id = beneficio.getId();
        this.beneficio = beneficio.getBeneficio();
        this.projetoId = beneficio.getProjeto().getId();
    }

    public BeneficioDTO(Long id, String beneficio, Long projetoId) {
        this.id = id;
        this.beneficio = beneficio;
        this.projetoId = projetoId;
    }

    static public List<BeneficioDTO> deLista(List<Beneficio> beneficioList) {
        List<BeneficioDTO> list = new ArrayList<>();
        beneficioList.forEach(beneficio1 ->
                list.add(new BeneficioDTO(beneficio1))
                );
        return list;
    }
}
