package SGP_Backend.SGP_Backend.model;

import jakarta.persistence.*;
import lombok.*;

import java.util.List;
import java.util.Objects;

@Builder
@Entity
@AllArgsConstructor
@NoArgsConstructor
@Getter
@Setter
@Table(name = "beneficio")
@EqualsAndHashCode
public class Beneficio {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;
    private String beneficio;
    @OneToOne
    @JoinColumn(name = "projeto_id")
    private Projeto projeto;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Beneficio that = (Beneficio) o;
        return Objects.equals(id, that.id) &&
                Objects.equals(beneficio, that.beneficio) &&
                Objects.equals(projeto, that.projeto);
    }

    @Override
    public int hashCode() {
        return Objects.hash(id, beneficio, projeto);
    }
}

