package SGP_Backend.SGP_Backend.service;

import SGP_Backend.SGP_Backend.dto.BeneficioDTO;
import SGP_Backend.SGP_Backend.model.Beneficio;
import SGP_Backend.SGP_Backend.model.Projeto;
import lombok.AllArgsConstructor;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.stream.Collectors;

import SGP_Backend.SGP_Backend.repository.BeneficioRepository;
import SGP_Backend.SGP_Backend.repository.ProjetoRepository;

@AllArgsConstructor
@Service
public class BeneficioService {

    private final BeneficioRepository beneficioRepository;
    private final ProjetoRepository projetoRepository;

    public List<Beneficio> cadastrarBeneficio(Long id, List<String> beneficios) {
        Projeto projeto = projetoRepository.findById(id)
                .orElseThrow(() -> new IllegalArgumentException("Projeto não encontrado com o ID: " + id));

        List<Beneficio> beneficioEntities = beneficios.stream()
                .map(descricao -> {
                    Beneficio beneficio = new Beneficio();
                    beneficio.setProjeto(projeto);
                    beneficio.setBeneficio(descricao);
                    return beneficio;
                })
                .collect(Collectors.toList());

        return beneficioRepository.saveAll(beneficioEntities);
    }
}